<!DOCTYPE html>
<html lang="en">

<head>
    <title>RealWebChat art-frela</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js"></script>
    <style>
        .fakeimg {
            height: 200px;
            background: #aaa;
        }
    </style>
</head>

<body>
    <nav class="navbar navbar-expand-sm bg-dark navbar-dark">
        <a class="navbar-brand" href="#">Chat</a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#collapsibleNavbar">
            <span class="navbar-toggler-icon"></span>
        </button>
        <div class="collapse navbar-collapse" id="collapsibleNavbar">
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" href="#">Patterns</a>
                </li>
                <li class="nav-item">
                    <a class="nav-link" href="#">Structures</a>
                </li>
            </ul>
        </div>
    </nav>

    <div class="container" style="margin-top:30px">
        <div class="row">
            <div class="col-sm-8">
                <div class="input-group mb-3" id="controls">
                    <input type="text" class="form-control" id="message" placeholder="введите сообщение">
                    <div class="input-group-append">
                        <button class="btn btn-success" type="submit" id="send">Go</button>
                    </div>
                </div>
                <div id="dialog"></div>
            </div>
        </div>
    </div>

    <div class="jumbotron text-center" style="margin-bottom:0">
        <p>Footer</p>
    </div>

</body>

<script>

    let comps = {
        dialog: document.querySelector('#dialog'),
        message: document.querySelector('#controls #message'),
        send: document.querySelector('#controls #send'),
    };

    let ws = new WebSocket('ws://' + document.location.host + '/ws');
    ws.onclose = () => console.log('closed');

    comps.send.onclick = () => {

        ws.send(comps.message.value);
        comps.message.value = '';
    };

    ws.onmessage = e => {
        //console.log(e);
        let msg = JSON.parse(e.data);
        if (msg.type === 'ping') {
            ws.send(JSON.stringify({ type: 'pong' }));
            return;
        }
        var currentdate = new Date();
        var datetime = "at: " 
            + currentdate.getHours() + ":"
            + currentdate.getMinutes() + ":"
            + currentdate.getSeconds() + " @ "
            + currentdate.getFullYear() + "-"
            + (currentdate.getMonth()+ 1) + "-"
            + currentdate.getDate();
            
        let msgComponent = document.createElement('DIV');
        msgComponent.innerHTML = `<div class="media border p-3">
            <img src="img_avatar3.png" alt="John Doe" class="mr-3 mt-3 rounded-circle" style="width:30px;">
                <div class="media-body">
                    <h4>`+ msg.author +` <small><i>`+datetime+`</i></small></h4>
                    <p>`+ msg.body+`</p>
                </div>
        </div>`;
        comps.dialog.prepend(msgComponent);
        //comps.dialog.appendChild(msgComponent);
    };

    ws.onopen = () => {
        console.log('connected');
    };

    var btn = document.getElementById('message');
    btn.onkeydown = function (e) {
        e = e || window.event;
        var keyCode = e.keyCode || e.which;
        if (keyCode == 13) {
            ws.send(comps.message.value);
            comps.message.value = '';
        }
    };
</script>
</html>